package ru.landgrafhomyak.db.serdha0.api.module

import kotlin.jvm.JvmName
import ru.landgrafhomyak.db.serdha0.api.table.Table
import ru.landgrafhomyak.db.serdha0.api.table.TableConstructor


public interface UpgradeModuleScope<omUE : Any> : CreateModuleScope {
	@Suppress("INAPPLICABLE_JVM_NAME")
	@get:JvmName("oldModule")
	public val oldModule: omUE

	public interface TableUpgrade<tnUE : Any, toUE : Any> {
		public fun upgradeTable(oldTable: Table<toUE, *>, upgrade: TableUpgrade<tnUE, toUE>): tnUE
	}


	public fun <tUE : Any> keepTable(
		table: Table<tUE, *>,
	): Table<tUE, *>

	public fun <tUE : Any> renameTable(
		table: Table<tUE, *>,
		newNamespace: Namespace? = null,
		newName: String? = null
	): Table<tUE, *>

	public fun <tnUE : Any, toUE : Any> upgradeTable(
		oldTable: Table<toUE, *>,
		upgrade: TableUpgrade<tnUE, toUE>
	): Table<tnUE, toUE>


	public fun <tnUE : Any, toUE : Any> upgradeAndRenameTable(
		oldTable: Table<tnUE, toUE>,
		newNamespace: Namespace? = null,
		newName: String? = null,
		upgrade: TableUpgrade<tnUE, toUE>
	): Table<tnUE, toUE>

	public fun deleteTable(table: Table<*, *>)

	public fun deleteTableAfterModuleUpgraded(table: Table<*, *>)

	public fun <smUE : Any> upgradeModule(oldModule: Module<*>, rootNs: Namespace, template: ModuleTemplate<smUE>): Module<smUE>
}